<template>
  <div class="tenant">
    <!-- <Banner /> -->
    <div class="content">
      <byTable
        :source="sourceList.data"
        :pagination="sourceList.pagination"
        :config="config"
        :loading="loading"
        highlight-current-row
        :selectConfig="selectConfig"
        :table-events="{
          //element talbe事件都能传
          select: select,
        }"
        :action-list="[
          {
            text: '产品拆分',
            action: () => openModal('add'),
          },
        ]"
        @get-list="getList"
      >
        <template #slotName="{ item }">
          {{ item.createTime }}
        </template>
      </byTable>
    </div>
    <el-dialog
      :title="modalType == 'add' ? '产品拆分' : '拆分详情'"
      v-model="dialogVisible"
      width="800"
      v-loading="loading"
      destroy-on-close
    >
      <byForm
        :formConfig="formConfig"
        :formOption="formOption"
        v-model="formData.data"
        :rules="rules"
        ref="byform"
      >
        <template #products>
          <div style="width: 100%">
            <el-button
              type="primary"
              @click="openProduct = true"
              style="margin-bottom: 10px"
              v-if="modalType == 'add'"
            >
              选择产品
            </el-button>
            <el-table :data="formData.data.groupRecordDetailsList">
              <el-table-column prop="productName" label="产品名称" />
              <el-table-column
                prop="canSum"
                label="库存数量"
                v-if="modalType == 'add'"
              />
              <el-table-column prop="groupNum" label="拆分数量" min-width="150">
                <template #default="{ row, $index }">
                  <el-form-item
                    :prop="'groupRecordDetailsList.' + $index + '.groupNum'"
                    :rules="rules.groupNum"
                    :inline-message="true"
                  >
                    <el-input-number
                      v-model="row.groupNum"
                      :precision="0"
                      :controls="false"
                      :min="0"
                      onmousewheel="return false;"
                    />
                  </el-form-item>
                </template>
              </el-table-column>
              <el-table-column
                prop="zip"
                label="操作"
                width="100"
                v-if="modalType == 'add'"
              >
                <template #default="{ $index }">
                  <el-button type="primary" link @click="handleRemove($index)"
                    >删除</el-button
                  >
                </template>
              </el-table-column>
            </el-table>
          </div>
        </template>
      </byForm>
      <template #footer v-if="modalType == 'add'">
        <el-button @click="dialogVisible = false" size="large">取 消</el-button>
        <el-button
          type="primary"
          @click="submitForm('byform')"
          size="large"
          :loading="submitLoading"
        >
          确 定
        </el-button>
      </template>
    </el-dialog>
    <el-dialog
      v-model="openProduct"
      title="选择产品"
      width="70%"
      append-to-body
    >
      <SelectProduct @handleSelect="handleSelect"></SelectProduct>
      <template #footer>
        <span class="dialog-footer">
          <el-button @click="openProduct = false">取消</el-button>
        </span>
      </template>
    </el-dialog>
  </div>
</template>
  
<script setup>
/* eslint-disable vue/no-unused-components */
import { ElMessage, ElMessageBox } from "element-plus";
import byTable from "@/components/byTable/index";
import byForm from "@/components/byForm/index";
import { computed, defineComponent, ref, watch } from "vue";
import useUserStore from "@/store/modules/user";
import SelectProduct from "@/components/WDLY/product/SelectProduct";

const loading = ref(false);
const submitLoading = ref(false);
const sourceList = ref({
  data: [],
  pagination: {
    total: 3,
    pageNum: 1,
    pageSize: 10,
    type: "2",
  },
});
let dialogVisible = ref(false);
let openProduct = ref(false);

let roomDialogVisible = ref(false);
let modalType = ref("add");
let rules = ref({
  productWarehouseId: [
    { required: true, message: "请选择半成品所在仓库", trigger: "change" },
  ],
  groupWarehouseId: [
    { required: true, message: "请选择组合后放置仓库", trigger: "change" },
  ],
  groupNum: [{ required: true, message: "请输入拆分数量", trigger: "blur" }],
});
const { proxy } = getCurrentInstance();
const selectConfig = reactive([]);

const config = computed(() => {
  return [
    {
      attrs: {
        label: "组合编码",
        prop: "productCode",
      },
    },
    {
      attrs: {
        label: "组合名称",
        prop: "productName",
      },
    },
    {
      attrs: {
        label: "规格型号",
        prop: "productSpec",
      },
    },
    {
      attrs: {
        label: "拆分前所在仓库",
        prop: "groupWarehouseName",
      },
    },
    {
      attrs: {
        label: "拆分后放置仓库",
        prop: "productWarehouseName",
      },
    },
    {
      attrs: {
        label: "拆分数量",
        prop: "groupNum",
      },
    },
    {
      attrs: {
        label: "操作人",
        prop: "createUserName",
      },
    },
    {
      attrs: {
        label: "操作时间",
        prop: "createTime",
      },
    },
    {
      attrs: {
        label: "操作",
        width: "200",
        align: "right",
      },
      // 渲染 el-button，一般用在最后一列。
      renderHTML(row) {
        return [
          {
            attrs: {
              label: "查看",
              type: "primary",
              text: true,
            },
            el: "button",
            click() {
              getDtl(row);
            },
          },
        ];
      },
    },
  ];
});

let formData = reactive({
  data: {},
  treeData: [],
});
const formOption = reactive({
  inline: true,
  labelWidth: 100,
  itemWidth: 100,
  rules: [],
});
const byform = ref(null);
const treeData = ref([]);
const formConfig = reactive([
  {
    type: "title",
    title: "仓库信息",
  },
  {
    type: "select",
    prop: "groupWarehouseId",
    label: "拆分前所在仓库",
    itemWidth: 33,
    data: [],
  },
  {
    type: "select",
    prop: "productWarehouseId",
    label: "拆分后放置仓库",
    itemWidth: 33,
    data: [],
  },

  {
    type: "title",
    title: "拆分明细",
  },
  {
    type: "slot",
    slotName: "products",
  },
]);
const getList = async (req) => {
  sourceList.value.pagination = { ...sourceList.value.pagination, ...req };
  loading.value = true;
  proxy
    .post("/groupRecordDetails/page", sourceList.value.pagination)
    .then((message) => {
      console.log(message);
      sourceList.value.data = message.rows;
      sourceList.value.pagination.total = message.total;
      setTimeout(() => {
        loading.value = false;
      }, 200);
    });
};
const openModal = () => {
  dialogVisible.value = true;
  modalType.value = "add";
  formConfig[1].disabled = false;
  formConfig[2].disabled = false;
  formData.data = {
    type: "2",
    groupRecordDetailsList: [],
  };
};

const submitForm = () => {
  byform.value.handleSubmit((valid) => {
    const list = formData.data.groupRecordDetailsList;
    for (let i = 0; i < list.length; i++) {
      const e = list[i];
      if (e.groupNum == 0) {
        return ElMessage({
          message: "拆分数量不能为0！",
          type: "info",
        });
      }
      if (e.groupNum > Number(e.canSum)) {
        return ElMessage({
          message: "拆分数量不可大于库存数量！",
          type: "info",
        });
      }
    }
    submitLoading.value = true;
    const data = {
      type: formData.data.type,
      productWarehouseId: formData.data.productWarehouseId,
      groupWarehouseId: formData.data.groupWarehouseId,
      groupRecordDetailsList: list.map((x) => ({
        productId: x.productId,
        groupNum: x.groupNum,
      })),
    };
    proxy.post("/groupRecordDetails/" + modalType.value, data).then(
      (res) => {
        ElMessage({
          message: modalType.value == "add" ? "添加成功" : "编辑成功",
          type: "success",
        });
        dialogVisible.value = false;
        submitLoading.value = false;
        getList();
      },
      (err) => (submitLoading.value = false)
    );
  });
};

const getDtl = (row) => {
  modalType.value = "edit";
  proxy
    .post("/groupRecordDetails/detail", { id: row.groupRecordId })
    .then((res) => {
      formConfig[1].disabled = true;
      formConfig[2].disabled = true;
      formData.data.productWarehouseId = row.productWarehouseId;
      formData.data.groupWarehouseId = row.groupWarehouseId;
      formData.data.groupRecordDetailsList = res;
      dialogVisible.value = true;
    });
};

const warehouseList = ref([]);
const warehouseListData = () => {
  // // 币种数据
  proxy
    .post("/warehouse/page", {
      pageNum: 1,
      pageSize: 9999,
    })
    .then((message) => {
      warehouseList.value = message.rows;
      formConfig[1].data = message.rows.map((x) => ({
        label: x.name,
        value: x.id,
      }));
      formConfig[2].data = message.rows.map((x) => ({
        label: x.name,
        value: x.id,
      }));
    });
};
getList();
warehouseListData();

const handleSelect = (row) => {
  const flag = formData.data.groupRecordDetailsList.some(
    (x) => x.productId === row.id
  );
  if (flag)
    return ElMessage({
      message: "该物品已选择",
      type: "info",
    });
  formData.data.groupRecordDetailsList.push({
    productName: row.name,
    productCode: row.code,
    productSpec: row.spec,
    productId: row.id,
    groupNum: 0,
  });
  return ElMessage({
    message: "选择成功",
    type: "success",
  });
};

const handleRemove = (index) => {
  formData.data.groupRecordDetailsList.splice(index, 1);
  return ElMessage({
    message: "删除成功",
    type: "success",
  });
};

watchEffect(() => {
  const list = formData.data.groupRecordDetailsList;
  if (
    formData.data.groupWarehouseId &&
    list.length > 0 &&
    modalType.value == "add"
  ) {
    proxy
      .post("/stock/pageByWarehouse", {
        id: formData.data.groupWarehouseId,
        productIds: list.map((x) => x.productId),
      })
      .then((res) => {
        const productList = res.rows;
        for (let i = 0; i < list.length; i++) {
          const e = list[i];
          e.canSum = 0;
          for (let j = 0; j < productList.length; j++) {
            const x = productList[j];
            if (e.productId == x.productId) {
              e.canSum = x.quantity;
            }
          }
        }
      });
  }
});
</script>
  
<style lang="scss" scoped>
.tenant {
  padding: 20px;
}
</style>